##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
##############################################################################
package p3_calc;
use p3_ses;
use p3_conf;
use p3_uti;
use Exporter;
@ISA    = qw( Exporter );
@EXPORT = qw( main );
use strict;

sub main
{
  my $text;
  
  my $expr    = $SDA{ in_expr };
  my $memory  = $SDA{ memory };
  my $history = $SDA{ history };
  
  $expr =~ s/[^0-9\.\-\+\/\*\\% ]//gio;
  
  my $res;
  eval( "\$res = $expr" );
  
  $SDA{ hist_row } = !$SDA{ hist_row };
  my $clr = $SDA{ hist_row } ? $TC1 : $TC2;
  $history = "<tr bgcolor=$clr>
              <td widht=100%>&nbsp;<code>$expr</td>
              <td width=1%><code>=</td>
              <td align=right>&nbsp;<code>$res</td></tr>" . $history if $expr;
  
  $history = ""      if $SDA{ in_CH };
  $memory += $res    if $SDA{ in_MP };
  $memory -= $res    if $SDA{ in_MM };
  $memory  = $res    if $SDA{ in_MS };
  my $res2 = $memory if $SDA{ in_MR };
  $memory = 0 unless $memory;
  $SDA{ history } = $history;
  $SDA{ memory  } = $memory;
  
  $text .=  "
      <form action=$SCR?>
      <br><b>Memory = $memory<br>Expression:</b> <code>( allowed chars are: 0123456789+-*/% )</code><br>
        <b>
        <input name=expr size=40 value='$res2'>
        <input type=submit value=Evaluate>
        <input type=submit name=MP value=M+>
        <input type=submit name=MM value=M->
        <input type=submit name=MS value=M=>
        <input type=submit name=MR value=MR>
        <input type=submit name=CH value=CH>
      </b><br>
      <table width=50% cellspacing=0 cellpadding=4>$history</table>
      ";
  
  return $text;
};

1;
